{    var   : }
{ EPS }
Unit mnb8e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure mnb8e(N :Integer; var X :Array of Extended;
                var S :Array of Extended; var XX :Array of Extended;
                FUN :Proc_F1E_MN; AA :Extended; BB :Extended; EPSX :Extended;
                var EPS :Extended; ITMAX :Integer; MAXK :Integer;
                var FMIN :Extended; var XMIN :Extended;
                var KOUNT :Integer; var ITER :Integer; NACC :Integer;
                var IER :Integer);

implementation

procedure mnb8e(N :Integer; var X :Array of Extended;
                var S :Array of Extended; var XX :Array of Extended;
                FUN :Proc_F1E_MN; AA :Extended; BB :Extended; EPSX :Extended;
                var EPS :Extended; ITMAX :Integer; MAXK :Integer;
                var FMIN :Extended; var XMIN :Extended;
                var KOUNT :Integer; var ITER :Integer; NACC :Integer;
                var IER :Integer);
var
I,I1,ISW,IX,L :Integer;
A,B,T1 :Extended;
C :Array [0..1] of Extended;
FN :Array [0..1] of Extended;
V :Array [0..1] of Extended;
const
C1 :Extended = -2.078086921235027225125382e0;
ZERO :Extended = 0.0e0;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210;
begin
{   DATA  FORTRAN  }
C[0] := 3.819660112501051517954137e-1;
C[1] := 6.180339887498948482045855e-1;
{      -------------------------------------------------- }
{     OHOMEPHA MHMA YK MHOX EPEMEHHX }
{     O AAHHOMY HAPABEH  HA AAHHOM HTEPBAE }
{     METOOM 'OOTOO CEEH', BCEH POBOTC }
{     C BOHO TOHOCT }
{     APAMETP: }
{     N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX }
{     X     -HAAHA TOKA OCKA }
{     S     -BEKTOP H N - HAPABEHE OCKA }
{     XX    -PAO BEKTOP H N }
{     FUN   -M OPOPAMM BCEH YHK }
{     AA    -HH PAHA HTEPBAA, COEPAEO }
{           MHMYM }
{     BB    -BEPXH PAHA HTEPBAA }
{     EPSX  -TOHOCT BCEH TOK MHMYMA O }
{           APYMEHTY (KOHEH HTEPBA) }
{     EPS   -TOHOCT BCEH MHMYMA O YHKOHAY }
{     ITMAX -MAKCMAHOE CO TEPA }
{     MAXK  -MAKCMAHOE CO BCEH YHK }
{     FMIN  -BCEHHOE MHMAHOE HAEHE YHK }
{     XMIN  -PACCTOHE OT X O BCEHHO TOK }
{           MHMYMA BO S }
{     KOUNT -BOHEHHOE CO BCEH YHK }
{     ITER  -BOHEHHOE CO TEPA }
{     NACC  -PHAK BAPAHTA AOPTMA: }
{            NACC=1-HA KAO TEPA BCETC }
{                  TOKO OHA KOHTPOHA TOKA }
{            NACC=2-BCTC OE TOK }
{     IER   -PHAK OKOHAH POECCA: }
{            IER= 1-OCTHYTA TOHOCT EPS }
{            IER= 2-OCTHYTA TOHOCT EPSX }
{            IER=65-AAHH EPSX.LE.0 }
{            IER=66-EC (BB-AA).LE.0.OR.EPSX.GT.(BB-AA) }
{            IER=67-BOHEHO ITMAX TEPA }
{            IER=68-BOHEHO MAXK BCEH YHK }
{      -------------------------------------------------- }

{ ---------- }
{      ***MAHOABCME KOHCTAHT** }


ITER := 0;
IER := 0;
KOUNT := 0;
if ( EPSX >  ZERO ) 
 then goto _10;
{ ---------- }
{      ***COOEHE, TO KOHEH HTEPBA*** }
{         MEHE  PABEH HY }

IER := 65;
goto _210;
_10:
T1 := BB - AA;
if ( T1 >  ZERO ) and (  T1 >=  EPSX )
 then goto _20;
{ ---------- }
{      ***COOEHE, TO HAAH HTEBA HE*** }
{         OOTEH  TO KOHEH HTEPBA }
{         OE EM HAAH }

IER := 66;
goto _210;
_20:
A := AA;
B := BB;
_30:
V[1] := C[1]*(B - A) + A;
for L:=1 to N do
 begin
  XX[L-1] := X[L-1] + V[1]*S[L-1];
_40:
 end;
FUN(XX,FN[1],EPS);
KOUNT := KOUNT + 1;
I1 := Trunc( C1*Ln(EPSX/(B-A)) + 1 );
IX := 1;
{ ---------- }
{      ***HAAHM HTEPBAOM BETC (A,B)*** }
{         V(1)  V(2)-KOHTPOHE TOK }

ISW := 0;
for I:=1 to I1 do
 begin
  ITER := ITER + 1;
  if ( ITER <=  ITMAX ) 
   then goto _50;
{ ---------- }
{      ***BOHEHO ITMAX TEPA }

  IER := 67;
  goto _180;
_50:
  V[IX-1] := C[IX-1]*(B - A) + A;
  for L:=1 to N do
   begin
    XX[L-1] := X[L-1] + V[IX-1]*S[L-1];
_60:
   end;
  FUN(XX,FN[IX-1],EPS);
  KOUNT := KOUNT + 1;
  if ( KOUNT <=  MAXK ) 
   then goto _70;
{ ---------- }
{      ***BOHEHO MAXK BCEH YHK }

  IER := 68;
  goto _180;
_70:
{ ---------- }
{      ***EC HTEPBA OTEPH, TO BOCCTAHOBEHE }

  if ( V[1] <=  V[0] ) 
   then goto _30;
  if ( Abs(FN[0] - FN[1]) >  EPS*EMax1(Abs(FN[0]),Abs(
       FN[1])) ) 
   then goto _90;
  if ( ISW <>  0 )
   then goto _80;
  ISW := 1;
  goto _100;

{      ***OCTHYTA TOHOCT O YHKOHAY }

_80:
  IER := 1;
  goto _180;
_90:
  ISW := 0;
_100:
  if ( FN[0] <  FN[1] ) 
   then goto _130;
  IX := 2;
  A := V[0];

{      ***CTAP V(2) CTAHOBTC HOBM V(1)*** }

  V[0] := V[1];
  FN[0] := FN[1];
  if ( Abs(B-A) >  EPSX ) 
   then goto _110;
  IER := 2;
  goto _180;
_110:
  if ( NACC <  2 ) 
   then goto _160;
  V[0] := C[0]*(B - A) + A;
  for L:=1 to N do
   begin
    XX[L-1] := X[L-1] + V[0]*S[L-1];
_120:
   end;
  FUN(XX,FN[0],EPS);
  KOUNT := KOUNT + 1;
  goto _160;
_130:
  IX := 1;
  B := V[1];

{      ***CTAP V(1) CTAHOBTC HOBM V(2)*** }

  V[1] := V[0];
  FN[1] := FN[0];
  if ( Abs(B-A) >  EPSX ) 
   then goto _140;
  IER := 2;
  goto _180;
_140:
  if ( NACC <  2 ) 
   then goto _160;
  V[1] := C[1]*(B - A) + A;
  for L:=1 to N do
   begin
    XX[L-1] := X[L-1] + V[1]*S[L-1];
_150:
   end;
  FUN(XX,FN[1],EPS);
  KOUNT := KOUNT + 1;
_160:
_170:
 end;
goto _30;
{ ---------- }
{      ***OKOHAHE OCKA. OPEEEHE }
{         BXOHX APAMETPOB }

_180:
if ( FN[1] - FN[0] ) < 0
 then goto _190
 else if ( FN[1] - FN[0] ) > 0
       then goto _200
       else goto _190;
_190:
FMIN := FN[1];
XMIN := V[1];
goto _210;
_200:
FMIN := FN[0];
XMIN := V[0];
_210:
end;

end.
